bremswagen = {};

function bremswagen.prerequisitesPresent(specializations)
    return true;
end;

function bremswagen:load(xmlFile)

	self.playStartSound = SpecializationUtil.callSpecializationsFunction("playStartSound");
	self.playEndSound = SpecializationUtil.callSpecializationsFunction("playEndSound");
	self.anim = SpecializationUtil.callSpecializationsFunction("anim");
	self.Go = {}; 
	self.Done = {};
	self.charId = {};
	self.clipIndex = {};
	self.CheckDone = {};
    self.animationParts = {};
	self.startpoint = {};
	self.loopCheck = {};
	self.Speed = {};
	local count = getXMLInt(xmlFile, "vehicle.animationParts#count");
	local part = self.animationParts;
	if count ~= nil then
	    for i=1, count do
			part[i] = {};
	        local partname = string.format("vehicle.animationParts.part".."%d", i);
		    local nameR = getXMLString(xmlFile, partname.."#name");
			self.charId[nameR] = Utils.indexToObject(self.components, getXMLString(xmlFile, partname.."#rootNode"));
			self.clipIndex[nameR] = getXMLString(xmlFile, partname.."#animationClip");
			self.CheckDone[nameR] = false;
			self.startpoint[nameR] = Utils.getNoNil(getXMLFloat(xmlFile, partname.."#startpoint"),0.0);
			self.Speed[nameR] = Utils.getNoNil(getXMLFloat(xmlFile, partname.."#speed"),0.0);
			local charId = getAnimCharacterSet(self.charId[nameR]);
			local clipIndex = getAnimClipIndex(charId, self.clipIndex[nameR]);
			assignAnimTrackClip(charId , 0, clipIndex);
			setAnimTrackTime(charId, 0, self.startpoint[nameR]);
			enableAnimTrack(charId, 0);
			disableAnimTrack(charId, 0);
			self.loopCheck[nameR] = false;
			self.Speed[nameR] = 1.0;
		end; 
	end; 
	self.schild = {};
    self.schild[1] = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.status#aus"));
    self.schild[2] = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.status#rot"));
    self.schild[3] = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.status#gelb"));
    self.schild[4] = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.status#gruen"));
    for i=1,table.getn(self.schild) do
    	setVisibility(self.schild[i],false);
    end;
    setVisibility(self.schild[1],true);	
	self.fullpull = Utils.getNoNil(getXMLInt(xmlFile,"vehicle.fullpull#value"),100);
	self.weightMinTrans = {0,0,Utils.getNoNil(getXMLFloat(xmlFile,"vehicle.gewicht#minTrans"),0)};
    self.weightMaxTrans = {0,0,Utils.getNoNil(getXMLFloat(xmlFile,"vehicle.gewicht#maxTrans"),0)};
    self.weightMoveLimit = self.weightMaxTrans[3]-self.weightMinTrans[3];
    local w1,w2,w3,w4, w5, w6, w7, w8, w9, w10, w11, w12, w13, w14, w15, w16, w17, w18 = Utils.getVectorFromString(getXMLString(xmlFile,"vehicle.gewicht#klassen"));
    self.weightClasses = {};
    self.weightClasses[1] = Utils.getNoNil(w1,11);
    self.weightClasses[2] = Utils.getNoNil(w2,16);
    self.weightClasses[3] = Utils.getNoNil(w3,18);
    self.weightClasses[4] = Utils.getNoNil(w4,23);
    self.weightClasses[5] = Utils.getNoNil(w5,50);
    self.weightClasses[6] = Utils.getNoNil(w6,75);
    self.weightClasses[7] = Utils.getNoNil(w7,100);
    self.weightClasses[8] = Utils.getNoNil(w8,200);
    self.weightClasses[9] = Utils.getNoNil(w9,250);
    self.weightClasses[10] = Utils.getNoNil(w10,300);
    self.weightClasses[11] = Utils.getNoNil(w11,350);
    self.weightClasses[12] = Utils.getNoNil(w12,400);
    self.weightClasses[13] = Utils.getNoNil(w13,450);
    self.weightClasses[14] = Utils.getNoNil(w14,500);
    self.weightClasses[15] = Utils.getNoNil(w15,550);
    self.weightClasses[16] = Utils.getNoNil(w16,600);
    self.weightClasses[17] = Utils.getNoNil(w17,650);
    self.weightClasses[18] = Utils.getNoNil(w18,700);
	
	self.hubPath = Utils.getFilename("$dataS/missions/hud_env_base.png", self.baseDirectory);
	self.hudInfoPosX = 0.3;
    self.hudInfoPosY = 0.018; --old 0.91;
    self.hudInfoWidth = 0.4;
    self.hudInfoHeight = 0.072;
    self.hudInfoOverlay = Overlay:new("hudInfoOverlay", self.hubPath, self.hudInfoPosX, self.hudInfoPosY, self.hudInfoWidth, self.hudInfoHeight);
	
	local startSound = getXMLString(xmlFile, "vehicle.sounds#startSound");
    if startSound ~= nil and startSound ~= "" then
        startSound = Utils.getFilename(startSound, self.baseDirectory); 
        self.startSound = createSample("startSound");
        self.startSoundEnabled = false;
		self.startSoundTime = 0;
        loadSample(self.startSound, startSound, false);
    end;
	self.startSoundPlayTime = getSampleDuration(self.startSound);
	local endSound = getXMLString(xmlFile, "vehicle.sounds#endSound");
	if endSound ~= nil and endSound ~= "" then
        endSound = Utils.getFilename(endSound, self.baseDirectory); 
        self.endSound = createSample("endSound");
        self.endSoundEnabled = false;
		self.endSoundTime = 0;
        loadSample(self.endSound, endSound, false);
    end;
	self.endSoundPlayTime = getSampleDuration(self.endSound);
	self.waiting = 0;
	self.weightclass = 1;
    self.isActive = false;
    self.status = "WAIT...";
    self.reset = true;
    self.distance = 0;
    self.ready = false;
    self.startPos = {getWorldTranslation(self.components[1].node)};
    self.watchTrack = false;
    self.timer = 0;
	self.transportMode = true;
	self.trailerWeight = getMass(self.components[2].node);
end;

function bremswagen:delete()
	if self.endSound ~= nil then
        delete(self.endSound);
    end;
	if self.startSound ~= nil then
        delete(self.startSound);
    end;
	if self.hudInfoOverlay ~= nil then
		delete(self.hudInfoOverlay);
	end;
end;

function bremswagen:mouseEvent(posX, posY, isDown, isUp, button)
end;

function bremswagen:keyEvent(unicode, sym, modifier, isDown)
end; 

function bremswagen:update(dt) 
	for i=1, table.getn(self.componentJoints) do
		local joint = self.componentJoints[i];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
	end;
	self:anim("hubTrailer", false);
	if self.CheckDone.hubTrailer then
		setWheelShapeProps(self.wheels[1].node, self.wheels[1].wheelShape, 0, 50, self.wheels[1].steeringAngle);
		setWheelShapeProps(self.wheels[2].node, self.wheels[2].wheelShape, 0, 50, self.wheels[2].steeringAngle);
	end;
	if self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.Bremswagen_Mode) then
			self.transportMode = not self.transportMode;
			if not self.transportMode then
				self.reset=true;
				self.ready=false;
				setMass(self.components[2].node, self.weightClasses[self.weightclass]);
			end;
		end;
		if self.waiting == 0 then
			self.startSoundEnabled = false;
			self.endSoundEnabled = false;
		end;
		if self.transportMode then
			self.Go.hubTrailer = false;
			self.Done.hubTrailer = true;
			self.isActive = false;
			setMass(self.components[2].node, (self.trailerWeight));
			local x, y, z = getTranslation(self.componentJoints[2].jointNode);
			local trans = {x,y,z};
			local newTrans = Utils.getMovedLimitedValues(trans, self.weightMaxTrans, self.weightMinTrans, 3, 5000, dt, self.transportMode);
			setTranslation(self.componentJoints[2].jointNode, unpack(newTrans));
			self.waiting = 0;
		else
			if InputBinding.hasEvent(InputBinding.Bremswagen_WatchTrack) then
				self.watchTrack = not self.watchTrack;
			end;
			if InputBinding.hasEvent(InputBinding.Bremswagen_SwitchWeight) then
				self.weightclass = self.weightclass + 1;
				self.reset = true;
				self.ready = false;
				if self.weightclass > table.getn(self.weightClasses) then
					self.weightclass = 1;
				end;
				setMass(self.components[2].node, self.weightClasses[self.weightclass]);
			end;
			if self.status ~= "GO..." then
				if InputBinding.hasEvent(InputBinding.Bremswagen_Reset) then
					self.reset = true;
					self.ready = false;
				end;
			end;
			if self.isActive and self.ready then
				local newPos = {getWorldTranslation(self.components[2].node)};
				local distance = Utils.vector2Length(newPos[1]-self.startPos[1], newPos[3]-self.startPos[3]);
				if distance > 0.05 and (distance - self.distance) < (0.0001*dt) then
					self.timer = self.timer + dt;
					if self.timer > 1000 then
						if not self.startSoundEnabled then
							self:playEndSound();
						end;
						self.status = "STOP";
						self.Speed.hubTrailer = 1.4;
						self.Go.hubTrailer = false;
						self.Done.hubTrailer = true;
						self.ready = false;
					end;
				else
					self.timer = 0;
				end;
				if self.status ~= "STOP" then
					self.distance = distance;
					self.status = "GO...";
					local x,y,z = getWorldTranslation(self.componentJoints[4].jointNode);
					local x1,y1,z1 = getWorldTranslation(self.componentJoints[3].jointNode);
					local x2,y2,z2 = getWorldTranslation(self.schild[1]);
					local dens = Utils.updateCultivatorArea(g_currentMission.cultivatorChannel, x, z, x1, z1, x2, z2);
					-- 80 min
					if dens < 80 and self.watchTrack then
						if not self.startSoundEnabled then
							self:playEndSound();
						end;
						self.status = "FOUL";
						self.Speed.hubTrailer = 1.4;
						self.Go.hubTrailer = false;
						self.Done.hubTrailer = true;
						self.ready = false;
					end;
				end;
				if self.distance > 0.05 and self.distance < self.fullpull then 
					self.reset = false;
					local newZ = self.weightMoveLimit * self.distance / self.fullpull;
					setTranslation(self.componentJoints[2].jointNode, 0,0,newZ);
				elseif self.distance >= self.fullpull then
					self.status = "FULLPULL";
					if not self.startSoundEnabled then
						self:playEndSound();
					end;
					self.Speed.hubTrailer = 1.4;
					self.Go.hubTrailer = false;
					self.Done.hubTrailer = true;
					self.distance = self.fullpull;
					self.ready = false;
				end;
			end;
			if self.reset and not self.ready then
				local x, y, z = getTranslation(self.componentJoints[2].jointNode);
				local trans = {x,y,z};
				self.Go.hubTrailer = true;
				self.Done.hubTrailer = true;
				if z == self.weightMinTrans[3] then
					if not self.endSoundEnabled then
						self:playStartSound();
					end;
					if self.waiting < 3800 then 
						self.waiting = self.waiting + dt;
					else
						self.ready = true; 
						self.startPos = {getWorldTranslation(self.components[2].node)}; 
						self.distance = 0; 
						self.waiting = 0; 
					end;
				else
					self.Speed.hubTrailer = 2;
					self.Go.hubTrailer = false;
					self.Done.hubTrauler = true;
				end;
				self.status = "WAIT...";
				local newTrans = Utils.getMovedLimitedValues(trans, self.weightMaxTrans, self.weightMinTrans, 3, 8000, dt, self.reset);
				setTranslation(self.componentJoints[2].jointNode, unpack(newTrans));
			end;
		end;
	end;
end;

function bremswagen:playStartSound()
	if not self.startSoundEnabled and self:getIsActiveForSound() then
		self.startSoundEnabled = true;
		playSample(self.startSound, 1, 1, 0);
		setSamplePitch(self.startSound, 1);
	end;
end;

function bremswagen:playEndSound()
	if not self.endSoundEnabled and self:getIsActiveForSound() then
		playSample(self.endSound, 1, 1, 0);
		setSamplePitch(self.endSound, 1);
		self.endSoundEnabled = true;
	end;
end;

function bremswagen:draw()
	if self.transportMode then
		g_currentMission:addHelpButtonText(g_i18n:getText("Bremswagen_1"), InputBinding.Bremswagen_Mode);
	else
		g_currentMission:addHelpButtonText(g_i18n:getText("Bremswagen_2"), InputBinding.Bremswagen_Mode);
		if self.watchTrack then
			g_currentMission:addExtraPrintText("Taste "..string.upper(InputBinding.getKeyNamesOfDigitalAction(InputBinding.Bremswagen_WatchTrack))..": Streckenbegrenzung ausschalten");
		else 
			g_currentMission:addExtraPrintText("Taste "..string.upper(InputBinding.getKeyNamesOfDigitalAction(InputBinding.Bremswagen_WatchTrack))..": Streckenbegrenzung einschalten");
		end;
		if self.hudInfoOverlay then
			self.hudInfoOverlay:render();
		end;
		g_currentMission:addHelpButtonText(g_i18n:getText("Bremswagen_3"), InputBinding.Bremswagen_Reset);
		g_currentMission:addExtraPrintText("Taste "..string.upper(InputBinding.getKeyNamesOfDigitalAction(InputBinding.Bremswagen_SwitchWeight))..": Gewicht: "..self.weightClasses[self.weightclass]);
		local status;
		if self.status == "GO..." then
			if not self.startSoundEnabled then
				status = "GO...";
			else
				status = "WAIT...";
			end;
		else
			status = self.status;
		end;
		renderText((self.hudInfoPosX+0.005),(self.hudInfoPosY+0.04),0.03,string.format("Gewichtsklasse: %s\nEntfernung: %0.3f -- [%s]",self.weightClasses[self.weightclass],self.distance,status));
	end;
	if self.transportMode then
		setVisibility(self.schild[1], true);
		setVisibility(self.schild[2], false);
		setVisibility(self.schild[3], false);
		setVisibility(self.schild[4], false);
	else
		local neu = 0;
		if self.status == "GO..." and not getVisibility(self.schild[4]) then
				neu = 4;
		elseif (self.status == "STOP" or self.status == "FOUL" or self.status == "FULLPULL") and not getVisibility(self.schild[2]) then
				neu = 2;
		elseif self.status == "WAIT..." and not getVisibility(self.schild[3]) then
				neu = 3;
		elseif self.transportMode and not getVisibility(self.schild[1]) then
				neu = 1;
		end;
		if neu > 0 then
			for i=0,table.getn(self.schild) do
				setVisibility(self.schild[i],false);
			end;
			setVisibility(self.schild[neu],true);
		end;
	end;
end;

function bremswagen:anim(varName, loopCheck)
	local loopCheck = self.loopCheck[varName];
	local speed = Utils.getNoNil(self.Speed[varName],1);
	local offset = 10;  
	local charId = getAnimCharacterSet(self.charId[varName]);
	local clipIndex = getAnimClipIndex(charId, self.clipIndex[varName]);
	if self.Done[varName] ~= false then
		if self.Go[varName] == true then
			assignAnimTrackClip(charId , 0, clipIndex);
			setAnimTrackLoopState(charId, 0, loopCheck);
			setAnimTrackSpeedScale(charId, 0, speed);
			enableAnimTrack(charId, 0);
			if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) and loopCheck == false then
				self.Done[varName] = false;	
				self.CheckDone[varName] = self.Go[varName];	
			end;
			if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) and loopCheck then
				local setTime = getAnimClipDuration(charId, clipIndex) - getAnimClipDuration(charId, clipIndex);
				setAnimTrackTime(charId, 0, setTime);
			end;
		elseif self.Go[varName] == false then
			if loopCheck == true then
				self.Done[varName] = false;	
			else
				assignAnimTrackClip(charId , 0, clipIndex);
				setAnimTrackLoopState(charId, 0, loopCheck);
				setAnimTrackSpeedScale(charId, 0, -speed);
				enableAnimTrack(charId, 0);
				if getAnimTrackTime(charId, 0) <= 0 then
					self.Done[varName] = false;	
					self.CheckDone[varName] = self.Go[varName];
				end;
			end;
		elseif self.Go[varName] ~= nil then
			assignAnimTrackClip(charId , 0, clipIndex);
			setAnimTrackLoopState(charId, 0, loopCheck);
			if self.Go[varName] < 0.0 then
				self.Go[varName] = 0.0;
			elseif self.Go[varName] > getAnimClipDuration(charId, clipIndex) then
				self.Go[varName] = getAnimClipDuration(charId, clipIndex);
			end;
			if getAnimTrackTime(charId, 0) >= self.Go[varName] then
				setAnimTrackSpeedScale(charId, 0, -speed);
			else
				setAnimTrackSpeedScale(charId, 0, speed);
			end;
			enableAnimTrack(charId, 0);
			if getAnimTrackTime(charId, 0) <= self.Go[varName] + offset and getAnimTrackTime(charId, 0) >= self.Go[varName] - offset then
				self.Done[varName] = false;	
				self.CheckDone[varName] = self.Go[varName];
			end;
		end;
	end;
	if self.Done[varName] == false then
		disableAnimTrack(charId, 0);
	end;
end;

function bremswagen:onAttach()
	setJointTranslationLimit(self.componentJoints[1].jointIndex, 0, true, 0, 0);
	setJointTranslationLimit(self.componentJoints[1].jointIndex, 1, true, -0.42, 0.42);
	setJointTranslationLimit(self.componentJoints[1].jointIndex, 2, true, 0, 0);
end;

function bremswagen:onDetach()
	for k,wheel in pairs(self.wheels) do
		setWheelShapeProps(wheel.node, wheel.wheelShape, 0, 0.5, wheel.steeringAngle);
	end;
	if self.startSoundEnabled then
		stopSample(self.startSound);
		self.startSoundEnabled = false;
	end;
	if self.endSoundEnabled then
		stopSample(self.endSound);
		self.endSoundEnabled = false;
	end;
end;